my $no_chdir=0;
my $jobs=1;
my $directory=getcwd();
+$ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
# globals :-(
my %config;
print "mr $action: running rcs test >>$test<<\n" if $verbose;
my $rcs=`$test`;
chomp $rcs;
+ if ($rcs=~/\n/s) {
+ $rcs=~s/\n/, /g;
+ print STDERR "mr $action: found multiple possible repository types ($rcs) for $topdir$subdir\n";
+ return undef;
+ }
if (! length $rcs) {
return undef;
}
} #}}}
sub findcommand { #{{{
- my ($action, $dir, $topdir, $subdir) = @_;
+ my ($action, $dir, $topdir, $subdir, $is_checkout) = @_;
if (exists $config{$topdir}{$subdir}{$action}) {
return $config{$topdir}{$subdir}{$action};
}
+ if ($is_checkout) {
+ return undef;
+ }
+
my $rcs=rcs_test(@_);
if (defined $rcs &&
$ENV{MR_CONFIG}=$configfiles{$topdir};
my $lib=exists $config{$topdir}{$subdir}{lib} ?
$config{$topdir}{$subdir}{lib}."\n" : "";
+ my $is_checkout=($action eq 'checkout');
- if ($action eq 'checkout') {
+ if ($is_checkout) {
if (-d $dir) {
print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
return SKIPPED;
}
$dir=~s/^(.*)\/[^\/]+\/?$/$1/;
-
- if (! -d $dir) {
- print "mr $action: creating parent directory $dir\n" if $verbose;
- system("mkdir", "-p", $dir);
- }
}
elsif ($action =~ /update/) {
if (! -d $dir) {
$ENV{MR_REPO}=$dir;
- my $skiptest=findcommand("skip", $dir, $topdir, $subdir);
- my $command=findcommand($action, $dir, $topdir, $subdir);
+ my $skiptest=findcommand("skip", $dir, $topdir, $subdir, $is_checkout);
+ my $command=findcommand($action, $dir, $topdir, $subdir, $is_checkout);
if (defined $skiptest) {
my $test="set -e;".$lib.
return SKIPPED;
}
}
-
+
+ if ($is_checkout && ! -d $dir) {
+ print "mr $action: creating parent directory $dir\n" if $verbose;
+ system("mkdir", "-p", $dir);
+ }
+
if (! $no_chdir && ! chdir($dir)) {
print STDERR "mr $action: failed to chdir to $dir: $!\n";
return FAILED;
}
$ENV{MR_REPO}=getcwd();
- my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT');
+ my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT', 0);
if (! defined $command) {
die "mr register: unknown repository type\n";
}
} #}}}
sub getopts { #{{{
- Getopt::Long::Configure("no_permute");
+ Getopt::Long::Configure("bundling", "no_permute");
my $result=GetOptions(
"d|directory=s" => sub { $directory=abs_path($_[1]) },
"c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
exit 2;
};
- $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
-
# This can happen if it's run in a directory that was removed
# or other strangeness.
if (! defined $directory) {
git_bare_test =
test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
- test "$(GIT_CONFIG="$MR_REPO"/config git-config --get core.bare)" = true
+ test "$(GIT_CONFIG="$MR_REPO"/config git config --get core.bare)" = true
svn_update = svn update "$@"
git_update = if [ "$@" ]; then git pull "$@"; else git pull -t origin master; fi
echo "Registering svn url: $url in $MR_CONFIG"
mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co '$url' '$MR_REPO'"
git_register =
- url="$(LANG=C git-config --get remote.origin.url)" || true
+ url="$(LANG=C git config --get remote.origin.url)" || true
if [ -z "$url" ]; then
error "cannot determine git url"
fi
echo "Registering darcs repository $url in $MR_CONFIG"
mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get '$url'p '$MR_REPO'"
git_bare_register =
- url="$(LANG=C GIT_CONFIG=config git-config --get remote.origin.url)" || true
+ url="$(LANG=C GIT_CONFIG=config git config --get remote.origin.url)" || true
if [ -z "$url" ]; then
error "cannot determine git url"
fi